
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Linux驱动的两种加载方式过程分析 / 憋错料</title>

    <meta name="description" content="Linux驱动的两种加载方式过程分析 一.概念简述 在Linux下可以通过两种方式加载驱动程序:静态加载和动态加载. 静态加载就是把驱动程序直接编译进内核,系统启动后可以直接调用.静态加载的缺点是调试起来比较麻烦,每次修改一个地方都要重新编译和下载内核,效率较低.若采用静态加载的驱动较多,会导致内核容量很大,浪费存储空间. 动态加载利用了Linux的module特性,可以在系统启动后用insmod命令添加模块(.ko),在不需要的时候用rmmod命令卸载模块,采用这种动态加载的方式便于驱动程序的调试,同时可以针对产品的功能需求,进行">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Linux驱动的两种加载方式过程分析</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>一、概念简述</p>
<p>在Linux下可以通过两种方式加载驱动程序：静态加载和动态加载。</p>
<p>静态加载就是把驱动程序直接编译进内核，系统启动后可以直接调用。静态加载的缺点是调试起来比较麻烦，每次修改一个地方都要重新编译和下载内核，效率较低。若采用静态加载的驱动较多，会导致内核容量很大，浪费存储空间。</p>
<p>动态加载利用了Linux的module特性，可以在系统启动后用insmod命令添加模块（.ko），在不需要的时候用rmmod命令卸载模块，采用这种动态加载的方式便于驱动程序的调试，同时可以针对产品的功能需求，进行内核的裁剪，将不需要的驱动去除，大大减小了内核的存储容量。</p>
<p>在台式机上，一般采用动态加载的方式；在嵌入式产品里，可以先采用动态加载的方式进行调试，调试成功后再编译进内核。</p>
<p>二、实例分析</p>
<p>下面以Linux下音频驱动的加载为例，分析两种方式的加载过程。</p>
<p>1、静态加载</p>
<p>1）解压内核，修改硬件架构和编译器；</p>
<p>将内核压缩文件linux-2.6.8.1-zzm.tar.bz2解压到/home/sxy/目录下，命令是<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA2MjExMTE4NDY3MTg=.jpg">，解压后得到内核源码目录文件linux-2.6.8.1-zzm，进入该目录，编辑Makefile文件，将ARCH改为arm，CROSS_CPMPILE改为arm-linux-，如下图所示：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA2MjExMTE4NTExMDk=.jpg"></p>
<p>保存后退出。</p>
<p>2）配置内核；</p>
<p>在内核源码树目录下，输入make menuconfig命令，进入内核配置界面，进入“Load an Alternate Configuration File”选项，载入配置文件kernel_2410.cfg，保存退出，过程如下图所示：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA2MjExMTE4NTU2NDA=.jpg"></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA2MjExMTE5MDAwOTM=.jpg"></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA2MjExMTE5MDM0Mzc=.jpg"></p>
<p>再次输入make menuconfig命令，编辑sound选项，<strong>将其编译进内核（*）</strong>，结果如下图所示，最后保存配置，退出。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA2MjExMTE5MDc0MjE=.jpg"></p>
<p>3）编译内核；</p>
<p>在源码树目录下输入make zImage命令，编译完成后可以在/arch/arm/boot/目录下生成zImage镜像文件。</p>
<p>4）下载内核</p>
<p>将内核镜像文件zImage下载到开发板上，当串口终端显示如下信息时，表示驱动加载成功。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA2MjExMTIyMTg2NTY=.jpg"></p>
<p>2、动态加载</p>
<p>1）解压内核，过程与静态编译时一样，略；</p>
<p>2） 配置内核，前面过程与静态编译时一样，再次输入命令make menuconfig，配置sound选项时，<strong>将其编译成模块（M）</strong>，结果如下图所示，最后保存配置，退出；</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA2MjExMTE5MTY2MjU=.jpg"></p>
<p>这样就将声卡驱动编译成模块，可以动态选择是否加载到内核中。</p>
<p>3）下载内核</p>
<p>将内核镜像文件zImage下载到开发板上，验证能否驱动声卡的过程如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA2MjExMTE5MzYwNzg=.jpg"></p>
<p>说明：首先，将虚拟机下的/home/目录挂载到开发板上的/tmp/目录下，然后<strong>先后</strong>加载soundcore.ko和<br />
 s3c2410-oss.ko两个模块，最后通过lsmod命令查看是否加载上声卡驱动，结果显示加载成功，这样就可以在应用空间编程，实现音频的录放等操作。</p>
<p><strong>PS：①采用make menuconfig命令时，选项*代表Y，表示将驱动编译进内核；M表示将驱动编译成模块；空代表N，表示不编译；</strong></p>
<p><strong>②内核文件与模块两者有很多东西必须匹配，编译器版本、源码版本、编译时的配置等，所以当内核文件修改了，譬如修改了驱动的编译选项（Y、M、N），那么就必须重新编译和下载内核，否则会出错。</strong></p>
<p>三、遇到的问题</p>
<p><strong>问题：</strong>动态加载过程中，出现下面错误：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA2MjExMTE5NDAwNjI=.jpg"></p>
<p>错误：注册和注销设备的符号未知。</p>
<p><strong>解决方法：</strong>寻找依赖关系，查看几个符号的定义，发现在soundcore.c文件中定义了以上几个函数，同时导出了符号，以register_sound_dsp为例，如下图所示：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA2MjExMTE5NDMyMDM=.jpg"></p>
<p>所以应该先加载soundcore.ko，后加载s3c2410-oss.ko。</p>
<p>注意：在Kconfig和Makefile文件中定义了依赖关系，也可以查找到问题的原因。</p>
<p>2014年6月21日星期六11时25分</p>
<p><P><A href="http://www.bubuko.com/infodetail-226150.html" rel="external nofollow noreferrer">Linux驱动的两种加载方式过程分析,布布扣,bubuko.com</A></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 02:51:24 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/linux/" title="linux">linux</a>, <a href="https://www.biecuoliao.com/tag/%e9%a9%b1%e5%8a%a8/" title="驱动">驱动</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Linux驱动的两种加载方式过程分析的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmOQQP3.html" rel="bookmark">Linux共享库两种加载方式简述</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				动态库技术通常能减少程序的大小,节省空间,提高效率,具有很高的灵活性,对于升级软件版本也更加容易.与静态库不同,动态库里面的函数不是执行程序本身 的一部分,而是在程序执行时按需载入,其执行代码可以同时在多个程序中共享.由于在编译过程中无法知道动态库函数的地址,所以需要在运行期间查找,这对程 序的性能会有影响. 共享库 对于共享库来讲,它只包括2个段:只读的代码段 和可修改的数据段.堆和栈段,只有进程才有.如果你在共享库的函数里,分配了一块内存,这段内存将被算在调用该函数的进程的堆中.代码段由于其			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/418KAq3.html" rel="bookmark">UIImage的两种加载方式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				UIImage的两种加载方式 1.有缓存:读取后放入缓存中下次可直接读取,适用于图片较少且频繁使用. [UIImage imageNamed:@&quot;文件名&quot;]: 在缓存中由系统管理,当收到memoryWarning时会释放这些内存资源. 2.无缓存:用完就释放掉,参数传的是全路径,适用于图片较多较大的情况下. NSString *path = [[NSBundlemainBundle] pathForResource: @&quot;1.png&quot;ofType: nil]; [U			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kgAdX0.html" rel="bookmark">【Android进阶篇】Fragment的两种加载方式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.概述 Fragment(碎片,片段)是在Android 3.0后才引入的,主要的目的是为了实现在大屏幕设备上的更加动态更加灵活的UI设计.这是因为平板电脑的屏幕比手机大得多,所以屏幕上可以放更多的组件,而不是简单地只是把手机上的组件放大.所以Fragment在应用中的是一个可重用的模块化组件,它有自己的布局.自己的生命周期,在一个Activity中可以包含多个Fragment. 二.在Activity中加载Fragment Fragment的加载方式包含两种:静态加载和动态加载.静态加载很简			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEkKzK3.html" rel="bookmark">ios 图片的两种加载方式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				控件加载图片,plist,懒加载,序列帧动画,添加动画效果. IOS中有2种加载图片的方式. 方式一:有缓存(图片所占用的内存会一直停留在程序中) [objc] view plaincopy + (UIImage *)imageNamed:(NSString *)name; 注:必须是png文件.需要把图片添加到 images.xcassets中 例如: [objc] view plaincopy @property (weak, nonatomic) IBOutlet UIImageView 			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVw9xx0.html" rel="bookmark">dll的两种加载方式（pend）&plus; delayload</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				看过关于动态库的调用例子,于是决定动手做一做:dll的对外接口声明头文件,Mydll.h: //Mydll.h #include &lt;stdio.h&gt; #include &lt;stdlib.h&gt; #include &quot;Public.h&quot; #define DLL_EXPORT /*extern &quot;c&quot;*/ __declspec(dllexport) //导出 #define CUST_API _stdcall //标准调用 DLL_EXPORT voi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mmb7ln0.html" rel="bookmark">Android动画Animation的两种加载执行方式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文以简单的AlphaAnimation(&quot;淡入淡出(透明度改变)&quot;动画)为例,简单的说明Android动画Animation的两种加载执行方法: (1) 直接写Java代码,制作Android动画. (2) 写XML配置文件,加载XML资源文件执行. 其实这两者是一致的.要知道,在Android中,凡是可以在XML文件完成的View,代码亦可完全写出来. 现在先给出一个Java代码完成的动画AlphaAnimation,AlphaAnimation功能简单,简言之,可以让一个View			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0n1ZENM.html" rel="bookmark">三种加载方式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				重点总结:    即:三种加载方式    1&gt;传统加载方式------默认路径:tomcat/bin/目录    2&gt;使用ServletContext对象-----默认路径:web应用(工程)目录    3&gt;使用类加载器------默认路径:WEB-INF/classes/目录 一.利用ServletContext对象读取资源文件--默认目录为:工程(应用)路径                重点方法:                        InputStream getReso			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDda8wM.html" rel="bookmark">hive--udf函数（开发-4种加载方式）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				h2 { color: #fff; background-color: #7CCD7C; padding: 3px; margin: 10px 0px } h3 { color: #fff; background-color: #008eb7; padding: 3px; margin: 10px 0px } UDF函数开发 标准函数(UDF):以一行数据中的一列或者多列数据作为参数然后返回解雇欧式一个值的函数,同样也可以返回一个复杂的对象,例如array,map,struct. 聚合函数(UD			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MonZBy4.html" rel="bookmark">MyBatis 延迟加载的三种加载方式深入，你get了吗？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				延迟加载 延迟加载对主对象都是直接加载,只有对关联对象是延迟加载. 延迟加载可以减轻数据库的压力, 延迟加载不可是一条SQL查询多表信息,这样构不成延迟加载,会形成直接加载. 延迟加载分为三种类型: 1.直接加载 执行完主对象之后,直接执行关联对象. 2.侵入式加载 在执行主对象详情的时候,执行关联对象. 3.深度延迟加载 执行完主对象或主对象详情不会执行关联对象,只有用到关联对象数据的时候才走深度延迟加载. 延迟加载默认情况下是关闭状态(false) 延迟加载下的侵入式加载默认情况下是开启状态			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eqJDp0.html" rel="bookmark" class="title">Postgresql学习笔记</a>
					<div>
						Postgresql源码安装: 从http://www.postgresql.org/download/下载源码v9.4.5编译安装 ./configuremakesumake install  // ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBALnv4.html" rel="bookmark" class="title">linux 基本操作笔记</a>
					<div>
						linux文件系统的实现 linux有一个树状结构来组织文件,数的顶端为根目录/,节点为目录,而末节点为所包含的数据文件.我们可以对文件进行多种操作,比如打开和读写. 存储设备分区 文件系统的最终目的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/388oel3.html" rel="bookmark" class="title">C&plus;&plus;11 virtual函数学习笔记</a>
					<div>
						#include&lt;iostream&gt; #include&lt;string&gt; using namespace std; class Base { public: Base(){} ~ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz5oGJ4.html" rel="bookmark" class="title">opencv 和 parfor</a>
					<div>
						一次遇到两个不熟悉的,因此在一起记一下. OpenCV的全称是:Open Source Computer Vision Library. OpenCv是一个基于(开源)发行的跨平台计算机视觉库,可以运 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDoLE74.html" rel="bookmark" class="title">解决自签名Applet仍然弹出安全警告框的方案</a>
					<div>
						我搜索了网上很多方案,都没有解决弹警告框的问题.自己摸索出以下方案: 1. 按自签名步骤生成keystore文件和cert证书 keytool -genkey -keystore hp.keystor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pzqg80.html" rel="bookmark" class="title">发送HTTPS请求</a>
					<div>
						package com.suning.epp.trt.util.r32epp; import java.io.BufferedInputStream; import java.io.IOExcepti ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bqnNwM.html" rel="bookmark" class="title">Spring Boot入门小程序</a>
					<div>
						1.首先在eclipse-javaee创建一个maven项目 groupId:springBootTest4(名字只是实例) artifactId:springBootTest4 打开pom.xml文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MElYm14.html" rel="bookmark" class="title">Discuz随机默认头像</a>
					<div>
						当用户在Discuz没有上传自己的头像,显示的是默认头像,那么可不可以让这个默认头像随机显示了,答案是可以的,实现起来也比较简单,如果你熟悉php的随机函数rand()的话. 先准备几张自己需要的默认 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AALVa4.html" rel="bookmark" class="title">shell 并发</a>
					<div>
						遇到的问题: ETL 作业调度,用shell控制.对于并行执行的作业,采用shell并行执行. #!/bin/bash for(( i = 0; i &lt; 10; i++ )) do { slee ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0R7gpp3.html" rel="bookmark" class="title">双色球随机一注</a>
					<div>
						封装补零函数:                        function toDouble(n){                                if(n &lt; 10){   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38pa2l3.html" rel="bookmark" class="title">java之date</a>
					<div>
						日期类 1.java.lang.System类 System类提供的public static long currentTimeMillis()用来返回当前时间与1970年1月1日0时0分0秒之间以毫 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWrQWG4.html" rel="bookmark" class="title">&period;Net 站点在Windows环境借助Nginx和Redis实现负载均衡系列（三）</a>
					<div>
						.Net 站点使用Redis存储Session信息,借助Redis实现多个站点公用Session信息 1.新建一个web项目,我新建的是一个空的MVC的项目. 新建好之后添加Home控制器,新建Ind ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ezbBZ3.html" rel="bookmark" class="title">&lbrack;RxJS&rsqb; Stopping a Stream with TakeUntil</a>
					<div>
						Observables often need to be stopped before they are completed. This lesson shows how to use takeUnt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nRDJP0.html" rel="bookmark" class="title">『C&plus;&plus; New Begin』让我再娱乐一次&hellip;&hellip;</a>
					<div>
						700+页的C++ Primer一会儿就翻了100页 (好吧……我在开玩笑) 刷Luogu OJ 试炼场玩.. 看看我能刷几天. 接下来. 我将在这里提供最肉麻的C++入门程序. 敬请期待哦~ 原ID ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jrjwE0.html" rel="bookmark" class="title">第七章感想</a>
					<div>
						     本章学习控制发光二极管,通过直接与硬件交互完成,控制开发板上的四个小灯.      LED驱动的实现原理可以开始编写led驱动了,与上一章步骤类似,通过命令和读写文件实现.首先创建led驱动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Qo1Lo0.html" rel="bookmark" class="title">&commat;property中有哪些属性关键字？&sol; &commat;property 后面可以有哪些修饰符？</a>
					<div>
						出题者简介: 孙源(sunnyxx),目前就职于百度 整理者简介:陈奕龙(子循),目前就职于滴滴出行. 转载者:豆电雨(starain)微信:doudianyu 属性可以拥有的特质分为四类: 原子性- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02oVon3.html" rel="bookmark" class="title">动态修改css文件中，具体的class中的个别属性值。</a>
					<div>
						//修改class的属性值 //javascript方式 function setCssClassProperty(pSheetObj,pClassName,pProperty,pValue) { v ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pgRvy3.html" rel="bookmark" class="title">C语言中的getchar和putchar详解</a>
					<div>
						首先给出&lt;The_C_Programming_Language&gt;这本书中的例子: #include &lt;stdio.h&gt; int main(){    int c;     c  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Qv6vwM.html" rel="bookmark" class="title">css样式重写</a>
					<div>
						//我们经常想修改插件的某一个或几个样式特性,并保留其它的样式.而不是把某个css全部重写一遍. /*原有样式*/.ninew {padding: 0 10px;width: 600px;height ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzXW1q3.html" rel="bookmark" class="title">C&plus;&plus;socket网络编程&lpar;跨平台&rpar;实战HTTP服务器&lpar;二&rpar;</a>
					<div>
						使用Socket创建TCP服务器 1首先了解一下TCP 1TCP是面向连接的,必须是三次握手之后 2TCP提供可靠连接,实现丢失重传,RTT的估算物理 网卡 网线都会影响 这个丢包 3TCP通过给所发 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
